--[[ 
	Qorey/Qruid/Qreath's (Horde - Ner'zhul - US PvP) modified version of
	Simple Buff Bars, Mayen/Selari (Horde) from Illidan (US) PvP (Shadowed from WoWInterface)

	Qorey: I do not take credit for this wonderful mod, I only modified it to include some options and to make it
               colorful. Most of the work was created by it's original author. Any comments in the code I made are preceded by
               by - - Q

	Todo List: 
		(Priority: Medium) Consider flashing the buff bars when it's getting close to running out
        (Priority: High) Fix the double refreshing of buffs due to updating CurrentBuffs[] in UNIT_AURA
        
]]

QoreysBB = LibStub("AceAddon-3.0"):NewAddon("QoreysBB", "AceEvent-3.0")

local L = QoreysBBLocals

local SML, MAINHAND_SLOT, OFFHAND_SLOT, MAINHAND_BUFF_INDEX, OFFHAND_BUFF_INDEX, TRACKING_INDEX
local playerUnit = "player"
local ENCHANT_ANCHOR = "tempEnchants"
local _G = getfenv(0)

--Q Added locals
local Classes = {}
local CurrentBuffs = {}

local QBBDebug = false;

local MissingBuffs = {
   ["Arcane Intellect"]=-1, ["Mark of the Wild"]=-1, ["Blessing of Wisdom"]=-1, ["Blessing of Might"]=-1, ["Blessing of Kings"]=-1,
   ["Blessing of Sanctuary"]=-1, ["Power Word: Fortitude"]=-1, ["Divine Spirit"]=-1, ["Shadow Protection"]=-1,
   ["Well Fed"]=-1, ["Flask of <...>"]=-1, 
}

local MissingBuffList = {
   ["Missing: Arcane Intellect"]=true, ["Missing: Mark of the Wild"]=true,	["Missing: Blessing of Kings"]=true, ["Missing: Blessing of Wisdom"]=true,
   ["Missing: Power Word: Fortitude"]=true, ["Missing: Divine Spirit"]=true, ["Missing: Blessing of Sanctuary"]=true,
   ["Missing: Blessing of Might"]=true, ["Missing: Shadow Protection"]=true, ["Missing: Well Fed"]=true,
   ["Missing: Flask of Pure Mojo/Distilled Wisdom"]=true, ["Missing: Flask of Endless Rage"]=true, ["Missing: Flask of Stoneblood/Endless Rage"]=true,
   ["Missing: Flask of the Frost Wyrm"]=true,
}


local StandardBuffs = {
   ["Scroll of Strength VII"]=true, 
   ["Arcane Intellect"]=true, ["Arcane Brilliance"]=true, ["Armistice"]=true, ["Greater Blessing of Might"]=true,
   ["Wyrmrest Champion"]=true, ["Mark of the Wild"]=true, ["Gift of the Wild"]=true, ["Greater Blessing of Wisdom"]=true,
   ["Power Word: Fortitude"]=true, ["Prayer of Fortitude"]=true, ["Divine Spirit"]=true, ["Prayer of Spirit"]=true,
   ["Blessing of Kings"]=true, ["Blessing of Wisdom"]=true, ["Blessing of Might"]=true, ["Blessing of Sanctuary"]=true,
   ["Haunted"]=true,["Blood Pact"]=true,["Abomination's Might"]=true,["Horn of Winter"]=true,["Improved Icy Talons"]=true,
   ["Shadow Protection"]=true,["Prayer of Shadow Protection"]=true,["Demonic Pact"]=true,["Fel Intelligence"]=true,
   ["Heroic Presence"]=true,["Inspiring Presence"]=true,["Commanding Shout"]=true,["Battle Shout"]=true,
   ["Greater Blessing of Sanctuary"]=true,["Greater Blessing of Kings"]=true,["Leader of the Pack"]=true,["Moonkin Aura"]=true,
   ["Wrath of Air Totem"]=true, ["Argent Champion"]=true, ["Black War Bear"]=true ,["Crusader Aura"]=true,
   ["Mana Spring"]=true, ["Retribution Aura"]=true, ["Devotion Aura"]=true, ["Concentration Aura"]=true, ["Shadow Resist Aura"]=true,
   ["Sanctity Aura"]=true, ["Frost Resistance Aura"]=true, ["Fire Resistance Aura"]=true, ["Blood Pact"]=true, ["Paranoia"]=true,
   ["Stoneskin"]=true, ["Concentration Aura"]=true, ["Flametongue Totem"]=true, ["Unleashed Rage"]=true,
   ["Totem of Wrath"]=true,["Stoneskin Totem"]=true,["Elemental Oath"]=true,["Windfury Totem"]=true, ["Strength of Earth"]=true,
   ["Replenishment"]=true, ["Tree of Life"]=true, ["Ancestral Fortitude"]=true,
   ["Fire Resistance"]=true, ["Divine Hymn"]=true, ["Protection of Ancient Kings"]=true,
   ["Inspiration"]=true, ["Essence of Wintergrasp"]=true, ["Cat Form"]=true, ["Dire Bear Form"]=true, 
   ["Thorns"]=true, ["Earth Shield"]=true, ["Abominable Might"]=true, ["Earthliving"]=true,   
   ["Honorless Target"]=true, ["Tree of Life"]=true, ["Grounding Totem Effect"]=true,
   ["Seal of Righteousness"]=true, ["Defend"]=true, ["Trueshot Aura"]=true, ["Shadow Resistance Aura"]=true,
   ["Nature Resistance"]=true, ["Divine Sacrifice"]=true,
   ["Frost Resistance Aura"]=true, ["Dalaran Brilliance"]=true, ["Dalaran Intellect"]=true, ["Aspect of the Pack"]=true, ["Frost Resistance"]=true,
   ["Path of Frost"]=true, ["Cozy Fire"]=true, ["Preparation"]=true, ["Spirit Heal"]=true, ["Waiting to Resurrect"]=true,
   ["Auto-repair"]=true, ["Major Agility"]=true, ["Track Humanoids"]=true, ["Flash of Light"]=true, ["Beacon of Light"]=true,
   ["Valor Medal of the First War"]=true, ["Dampen Magic"]=true, ["Rampage"]=true, ["Oil Refinery"]=true, ["Fire Shield"]=true,
   ["Moonkin Form"]=true, ["Inner Fire"]=true, ["Amplify Magic"]=true, ["Underwater Breathing"]=true, ["Detect Invisibility"]=true,
   ["Detect Greater Invisibility"]=true, ["Argent Dawn Commission"]=true, ["Winterfall Firewater"]=true,
   ["Battle Shout"]=true, ["Roar of Sacrifice"]=true, ["Master's Call"]=true, ["Reflection of Torment"]=true, ["Greatness"]=true,
   ["Undying Resolve"]=true, ["Revive Pet"]=true, ["Realm of Shadows"]=true, ["Ebon Champion"]=true,  
   ["Earthen Power"]=true, ["Healing Power"]=true, ["Champion of the Kirin Tor"]=true, ["Blood Pact"]=true, ["Sense Demons"]=true,
   ["Stamina"]=true,
   }

local MountBuffs = {
   ["Venomhide Ravasaur"]=true, ["White Polar Bear"]=true, ["Felsteed"]=true,
   ["Ochre Skeletal Warhorse"]=true,["Purple Skeletal Warhorse"]=true,["Swift Flight Form"]=true, ["Flight Form"]=true,
   ["Amani War Bear"]=true, ["Swift Purple Hawkstrider"]=true, ["Swift Purple Wind Rider"]=true, ["Magnificent Flying Carpet"]=true,
   ["Travel Form"]=true, ["Green Skeletal Warhorse"]=true, ["Bronze Drake"]=true, ["Mekgineer's Chopper"]=true, ["Black Stallion"]=true,
   ["Brown Horse"]=true, ["Chestnut Mare"]=true, ["Pinto"]=true, ["Brown Ram"]=true, ["Gray Ram"]=true, ["White Ram"]=true, ["Blue Mechanostrider"]=true,
   ["Green Mechanostrider"]=true, ["Red Mechanostrider"]=true, ["Unpainted Mechanostrider"]=true, ["Spotted Frostsaber"]=true, ["Striped Frostsaber"]=true,
   ["Striped Nightsaber"]=true, ["Striped Dawnsabre"]=true, ["Brown Elekk"]=true, ["Gray Elekk"]=true, ["Purple Elekk"]=true,
   ["Brown Wolf"]=true, ["Dire Wolf"]=true, ["Timber Wolf"]=true, ["Black Wolf"]=true, ["Brown Kodo"]=true, ["Gray Kodo"]=true, ["White Kodo"]=true,
   ["Great Brown Kodo"]=true, ["Great Gray Kodo"]=true, ["Great White Kodo"]=true, ["Black War Kodo"]=true, ["Thunderbluff Kodo"]=true,
   ["Great Golden Kodo"]=true,["Great Brewfest Kodo"]=true, ["Emerald Rapter"]=true, ["Turquoise Raptor"]=true, ["Violet Raptor"]=true,
   ["Blue Skeletal Horse"]=true, ["Brown Skeletal Horse"]=true, ["Black Skeletal Horse"]=true, ["Red Skeletal Horse"]=true,
   ["Blue Hawkstrider"]=true, ["Purple Hawkstrider"]=true, ["Red Hawkstrider"]=true, ["Swift Brown Steed"]=true, ["Swift Palomino"]=true, 
   ["Swift White Steed"]=true, ["Swift Brown Ram"]=true, ["Swift Gray Ram"]=true, ["Swift White Ram"]=true,
   ["Swift Green Mechanostrider"]=true, ["Swift White Mechanostrider"]=true, ["Swift Yellow Mechanostrider"]=true, ["Black Battlestrider"]=true,
   ["Gnomeregan Mechanostrider"]=true, ["Turbostrider"]=true, ["Swift Frostsaber"]=true, ["Swift Mistsaber"]=true, ["Swift Stormsaber"]=true,
   ["Winterspring Frostsaber"]=true, ["Great Blue Elekk"]=true, ["Great Green Elekk"]=true, ["Great Purple Elekk"]=true,
   ["Swift Brown Wolf"]=true, ["Swift Gray Wolf"]=true, ["Swift Timber Wolf"]=true, ["Swift Blue Raptor"]=true, ["Swift Olive Raptor"]=true,
   ["Swift Orange Raptor"]=true, ["Green Skeletal Warhorse"]=true, ["Ochre Skeletal Warhorse"]=true, ["Swift Green Hawkstrider"]=true,
   ["Swift Pink Hawkstrider"]=true, ["Black War Steed"]=true, ["Black War Ram"]=true, ["Black War Tiger"]=true, ["Black War Elekk"]=true,
   ["Black War Wolf"]=true, ["Swift Warstrider"]=true, ["Dark War Talbuk"]=true, ["Dark Riding Talbuk"]=true, ["Venomhide Ravasaur"]=true,
   ["Cobolt Riding Talbuk"]=true, ["Silver Riding Talbuk"]=true, ["Tan Riding Talbuk"]=true, ["White Riding Talbuk"]=true,
   ["Cobalt War Talbuk"]=true, ["Silver War Talbuk"]=true, ["Tan War Talbuk"]=true, ["White War Talbuk"]=true, ["Dark Riding Talbuk"]=true,
   ["Dark War Talbuk"]=true, ["Cobalt War Talbuk"]=true, ["Silver War Talbuk"]=true, ["Tan War Talbuk"]=true,
   ["White War Talbuk"]=true, ["Ice Mammoth"]=true, ["Grand Ice Mammoth"]=true, ["Stormpike Battle Charger"]=true,
   ["Frostwolf Howler"]=true, ["Deathcharger Reins"]=true, ["Swift Zulian Tiger"]=true, ["Swift Razzashi Raptor"]=true,
   ["Fiery Warhorse's Reins"]=true, ["Reins of the Raven Lord"]=true, ["White Polar Bear"]=true, ["Swift White Hawkstrider"]=true,
   ["Black Qiraj Resonating Crystal"]=true, ["Mechano-hog"]=true, ["Armored Brown Bear"]=true, ["Wooly Mammoth"]=true,
   ["Traveler's Tundra Mammoth"]=true, ["Exodar Elekk"]=true, ["Darnassian Nightsaber"]=true, ["Ironforge Ram"]=true,
   ["Stormwind Steed"]=true, ["Great Red Elkekk"]=true, ["Swift Moonsaber"]=true, ["Swift Violet Ram"]=true, ["Swift Gray Steed"]=true,
   ["Quel'dorei Steed"]=true, ["Forsaken Warhorse"]=true, ["Orgrimmar Wolf"]=true, ["Darkspear Raptor"]=true, ["White Skeletal Warhorse"]=true,
   ["Swift Burgundy Wolf"]=true, ["Swift Purple Raptor"]=true, ["Swift Red Hawkstrider"]=true, ["Sunreaver Hawkstrider"]=true, ["Argent Warhorse"]=true,
   ["Armored Snowy Gryphon"]=true, ["Armored Blue Wind Rider"]=true, ["Cenarion War Hippogryph"]=true, ["Reins of the Red Dreak"]=true,
   ["Reins of the Blue Drake"]=true, ["Reins of the Azure Drake"]=true, ["Ashes of Al'ar"]=true,["Reigns of the Black Drake"]=true,
   ["Reins of the Twilight Drake"]=true, ["Green Proto-Drake"]=true, ["Blue Proto-Drake"]=true, ["Time-Lost Proto-Drake"]=true,
   ["Mimiron's Head"]=true, ["Flying Machine Control"]=true, ["Turbo-Charged Flying Machine Control"]=true, ["Swift Nether Drake"]=true,
   ["Argent Hippogryph"]=true, ["Silver Covenant Hippogryph"]=true, ["Sunreaver Dragonhawk"]=true, ["Black War Bear"]=true,
   ["Crusader's White Warhorse"]=true, ["Crusader's Black Warhorse"]=true, ["Reins of the Albino Drake"]=true, ["Blue Dragonhawk Mount"]=true, ["Red Dragonhawk Mount"]=true,
   ["Plagued Proto-Drake"]=true, ["Black Proto-Drake"]=true, ["Violet Proto-Drake"]=true, ["Rusted Proto-Drake"]=true, ["Ironbound Proto-Drake"]=true,
   ["Fresh Holly"]=true, ["Preserved Holly"]=true, ["Fresh Brewfest Hops"]=true, ["Fresh Goblin Brewfest Hops"]=true, ["Fresh Dwarven Brewfest Hops"]=true,
   ["Preserved Brewfest Hops"]=true, ["Brewfest Ram"]=true, ["Swift Brewfest Ram"]=true, ["Great Brewfest Kodo"]=true, ["Rickety Magic Broom"]=true, ["Magic Broom"]=true,
   ["The Horseman's Reins"]=true, ["Sea Turtle"]=true, ["Riding Turtle"]=true, ["Spectral Tiger"]=true, ["Swift Spectral Tiger"]=true,
   ["X-51 Nether-Rocket"]=true, ["X-51 Nether-Rocket X-TREME"]=true, ["Big Battle Bear"]=true, ["Big Blizzard Bear"]=true, ["Swift Zhevra"]=true,
   ["Ebon Gryphon"]=true, ["Snowy Gryphon"]=true, ["Golden Gryphon"]=true, ["Loaned Gryphon Mount"]=true, -- I added this one for you, vv, in case you ever go alliance
   ["Swift Red Gryphon"]=true, ["Swift Blue Gryphon"]=true, ["Swift Green Gryphon"]=true, ["Swift Purple Gryphon"]=true,
   ["Tawny Wind Rider"]=true, ["Blue Wind Rider"]=true, ["Green Wind Rider"]=true, ["Loaned Wind Rider Mount"]=true, -- this one also, vv, since you'll probably use it until the end of forever.
   ["Swift Yellow Wind Rider"]=true, ["Swift Red Wind Rider"]=true, ["Swift Green Wind Rider"]=true, ["Dominion Over Acherus"]=true, ["Acherus Deathcharger"]=true, ["Black Hawkstrider"]=true,
   ["Winged Steed of the Ebon Blade"]=true, ["Dreadsteed"]=true, ["Albino Drake"]=true,
}

local ImportantBuffs = { 
	["Well Fed"]=true, ["Bloodlust"]=true, ["Flask of Pure Mojo"]=true, ["Flask of Distilled Wisdom"]=true,
	["Flask of Stoneblood"]=true, ["Flask of Endless Rage"]=true, ["Flask of the Frost Wyrm"]=true,
	["Lordaeron's Blessing"]=true, ["Rallying Cry of the Dragonslayer"]=true, ["Spirit of Zandalar"]=true,
	["Warchief's Blessing"]=true, ["Songflower Serenade"]=true, ["Power Infusion"]=true, ["Soulstone"]=true, ["Divine Intervention"]=true,
    ["Flask of the North"]=true, ["Lesser Flask of Toughness"]=true,
}

local TrackingBuffs = { 
   ["Find Minerals"]=true, ["Find Herbs"]=true, ["None"]=true, ["Renew"]=true, ["Lifebloom"]=true, 
   ["Regrowth"]=true, ["Rejuvenation"]=true, ["Wild Growth"]=true, ["Prayer of Mending"]=true, ["Riptide"]=true,
   ["Holy Mending"]=true,["Glyph of Prayer of Healing"]=true, ["Hymn of Hope"]=true,
   ["Sacred Shield"]=true, ["Renewed Hope"]=true, ["Power Word: Shield"]=true, ["Find Fish"]=true, ["Living Seed"]=true,
   ["Grace"]=true, ["Tenacity"]=true, ["Divine Aegis"]=true,["First Aid"]=true, ["Divine Shield"]=true,
}

local ProcBuffs = { 
   ["Now is the time!"]=true, ["Forethought Talisman"]=true, ["Mark of the White Stag"]=true, ["Food"]=true, 
   ["Drink"]=true, ["Embrace of the Spider"]=true, ["Praxis"]=true, ["Scale of Fates"]=true, ["Living Flame"]=true,
   ["Elusive Power"]=true, ["Zandalarian Hero Charm"]=true, ["Nature's Grace"]=true, ["Elune's Wrath"]=true, ["Blessing of the Moon Goddess"]=true,
   ["Holy Judgement"]=true, ["Evasion"]=true, ["Spiritual Trance"]=true, ["Energized"]=true,
   ["Volcanic Fury"]=true, ["Unholy Strength"]=true, 

   -- These are class specific, but they should be colored as a proc imo.
   ["Hot Streak"]=true, ["Fireball!"]=true, ["Missle Barrage"]=true, ["Nightfall"]=true, ["Spirit Tap"]=true,
   ["Blood Craze"]=true, ["Bloodthirst"]=true, ["Enraged"]=true,["Flurry"]=true, ["Netherwind Focus"]=true,
   ["Inspiration"]=true, ["Eclipse"]=true, ["Sudden Death"]=true, ["Retaliation"]=true, ["Unflinching Valor"]=true,
   ["Blade Barrier"]=true, ["Arcane Energy"]=true, ["Backdraft"]=true,
}

local BossBuffs = {
   ["Potent Pheromones"]=true, ["Storm Power"]=true, ["Toasty Fire"]=true, ["Starlight"]=true,
   ["Storm Cloud"]=true, ["Spiritual Immunity"]=true,

   --PVP Buffs
   ["Recruit"]=true, ["Lok'tar ogar!"]=true, ["Corporal"]=true, ["First Lieutenant"]=true,
   ["Fury of the Frostwolf"]=true, ["Tower Control"]=true, ["Greater Honor"]=true, ["Lok'tar"]=true,
}

local ClassSpecificBuffs = { 
    ["Bloody Vengence"]=true, ["Blood Fury"]=true, ["Demonic Knowledge"]=true,
    ["Enrage"]=true, ["Survival Instincts"]=true, ["Prowl"]=true, ["Barkskin"]=true, ["Savage Defense"]=true, 
    ["Iceblock"]=true, ["Invisibility"]=true, ["Icy Veins"]=true, ["Combustion"]=true, ["Clearcasting"]=true, 
    ["Blink"]=true, ["Focus Magic"]=true, ["Molten Armor"]=true, ["Ice Armor"]=true, ["Mage Armor"]=true, 
    ["Mana Shield"]=true, ["Ice Barrier"]=true, ["Frost Armor"]=true, ["Ice Block"]=true, ["Berserking"]=true, 
    ["Evocation"]=true, ["Innervate"]=true, ["Dash"]=true, ["Ferocious Inspiration"]=true, 
    ["Master Shapeshifter"]=true, ["Aspect of the Hawk"]=true, ["Aspect of the Monkey"]=true, ["Aspect of the Cheetah"]=true,
    ["Aspect of the Beast"]=true, ["Aspect of the Wild"]=true,  ["Rapid Fire"]=true, ["Eyes of the Beast"]=true,
    ["Deterrence"]=true, ["Demon Skin"]=true, ["Demon Armor"]=true, ["Fire Shield"]=true, ["Sacrifice"]=true,
    ["Eye of Kilrogg"]=true, ["Detect Lesser Invisibility"]=true, ["Demonic Sacrifice"]=true, ["Shadow Ward"]=true,
    ["Master Demonologist"]=true, ["Soul Link"]=true, ["Detect Greater Invisibility"]=true, ["Shadowform"]=true,
    ["Shadow Protection"]=true, ["Mind Control"]=true, ["Inner Focus"]=true, ["Vampiric Embrace"]=true, ["Fade"]=true,
    ["Power Infusion"]=true, ["Spirit of Redemption"]=true, ["Divine Protection"]=true, ["Fire Ward"]=true, ["Frost Ward"]=true,
    ["Presence of Mind"]=true, ["Shadowguard"]=true, ["Lightning Shield"]=true, ["Tiger's Fury"]=true, ["Righteous Fury"]=true,
    ["Berserker Rage"]=true, ["Bloodrage"]=true,  ["Deathwish"]=true, ["Recklessness"]=true, ["Frost Presence"]=true, 
    ["Seal of Wisdom"]=true, ["Seal of Light"]=true, ["Seal of Command"]=true, ["Seal of the Crusader"]=true, ["Seal of Righteousness"]=true,
    ["Seal of Justice"]=true, ["Seal of Vengeance"]=true, ["Aspect of the Dragonhawk"]=true, ["Aspect of the Viper"]=true, ["Sniper Training"]=true,
    ["Eagle Eye"]=true, ["Kill Command"]=true, ["Feign Death"]=true, ["Call Stabled Pet"]=true, ["Misdirection"]=true, ["The Beast Within"]=true,
    ["Rapid Killing"]=true, ["Rapid Recuperation"]=true, ["Quick Shots"]=true, ["Furious Howl"]=true, ["Call of the Wild"]=true, ["Lock and Load"]=true,
    ["Stoneform"]=true, ["Track Beasts"]=true, ["Track Humanoids"]=true, ["Track Undead"]=true, ["Track Hidden"]=true, ["Track Elementals"]=true,
    ["Track Demons"]=true, ["Track Giants"]=true, ["Track Dragonkin"]=true, ["Fingers of Frost"]=true, ["Unholy Presence"]=true, ["Blood Presence"]=true,
    ["Frost Presence"]=true, ["Bone Shield"]=true, ["Lichborne"]=true, ["Deathchill"]=true, ["Icy Talons"]=true, 
    ["Taste for Blood"]=true, ["Enraged Regeneration"]=true, ["Fel Armor"]=true, ["Life Tap"]=true, ["Divine Plea"]=true,
    ["Divine Favor"]=true, ["Divine Illumination"]=true,
 }



local frame = CreateFrame("Frame")

--Q Updated this function with new defaults
function QoreysBB:OnInitialize()
	self.defaults = {
		profile = {
			locked = false,
			showTrack = true,
			showExample = false,
			showExtras = false,
			showTemp = true,
			autoFilter = false,
			filtersEnabled = {["Caster"] = false, ["Physical"] = false},
			groups = {},
			anchors = {
				enabled = true,
                		fillTimeless=true,
				tempColor = {r = 0.5, g = 0.0, b = 0.5},
				color = {r = 0.41, g = 0.75, b = 1.0},
				Bosscolor = {r = 1.0, g = 0.27, b = 0.64},
				Importantcolor = {r = 0.58, g = 0.41, b = 0.79},
				ClassSpecificcolor = {r = 0.98, g = 0.71, b = 0.21},
				TrackingHealingcolor = {r = 0.56, g = 0.76, b = 0.13},
				Proccolor = {r = 1.0, g = 0.46, b = 0.13},
              			BackgroundAlphaWhite = false,
              			texture = "Minimalist",
				sortBy = "timeleft",
				iconPosition = "LEFT",
				height = 21,
				width = 200,
				maxRows = 100,
				scale = 1.0,
				alpha = 1.0,
				spacing = 0,
				colorByType = true,
				anchorSpacing = 20,
				anchorTo = "",
				showStack = true,
				font = "Friz Quadrata TT",
				fontSize = 14,
				passive = false,
				time = "hhmmss",
				stackFirst = false,
				position = { x = 600, y = 600 },
			},
		},
	}

	-- Setup defaults quickly for groups
        self.defaults.profile.groups.buffs = CopyTable(self.defaults.profile.anchors)
        self.defaults.profile.groups.buffs.name = L["Player buffs"]
        self.defaults.profile.groups.buffs.canFilter = true

        self.defaults.profile.groups.missing = CopyTable(self.defaults.profile.anchors)
        self.defaults.profile.groups.missing.color = {r = 0.77, g = 0.12, b = 0.23}
        self.defaults.profile.groups.missing.name = "Missing Buffs" --Q this needs to be localized
        self.defaults.profile.groups.missing.anchorTo = "buffs"
        self.defaults.profile.groups.missing.anchorSpacing = -21

        self.defaults.profile.groups.debuffs = CopyTable(self.defaults.profile.anchors)
        self.defaults.profile.groups.debuffs.color = { r = 1.0, g = 0.0, b = 0.0 }
        self.defaults.profile.groups.debuffs.anchorTo = "missing"
        self.defaults.profile.groups.debuffs.anchorSpacing = -21
    
        self.defaults.profile.groups.debuffs.name = L["Player debuffs"]

        self.defaults.profile.groups.tempEnchants = CopyTable(self.defaults.profile.anchors)
        self.defaults.profile.groups.tempEnchants.color = { r = 1.0, g = 0.3, b = 0.7 }
        self.defaults.profile.groups.tempEnchants.name = L["Temporary enchants"]
        self.defaults.profile.groups.tempEnchants.moveTo = "buffs"
	
	-- Initialize the DB
	self.db = LibStub:GetLibrary("AceDB-3.0"):New("QoreysBBDB", self.defaults, true)
	self.db.RegisterCallback(self, "OnProfileChanged", "Reload")
	self.db.RegisterCallback(self, "OnProfileCopied", "Reload")
	self.db.RegisterCallback(self, "OnProfileReset", "Reload")

	self.revision = tonumber(string.match("$Revision$", "(%d+)") or 1)
	
	-- Annnd so we can grab texture things
	SML = LibStub:GetLibrary("LibSharedMedia-3.0")
	SML.RegisterCallback(self, "LibSharedMedia_Registered", "ResourceRegistered")
	
	-- Create the needed group tables
	self.auras = {}
	self.groups = {}
	
	self:UpdateGroups()
	
	-- Setup the SlotIDs for Mainhand/Offhands
	MAINHAND_SLOT = GetInventorySlotInfo("MainHandSlot")
	OFFHAND_SLOT = GetInventorySlotInfo("SecondaryHandSlot")
	
	-- Setup the anchor the enchants go into
	if( self.db.profile.groups.tempEnchants.moveTo ~= "" ) then
		ENCHANT_ANCHOR = self.db.profile.groups.tempEnchants.moveTo
	end
	
	-- Kill Blizzards buff frame
	BuffFrame:UnregisterEvent("UNIT_AURA")
	TemporaryEnchantFrame:Hide()
	BuffFrame:Hide()
	
	-- Delay updating buffs until PEW, this way scaling and such is set correctly
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
end
-- Show the vehicle buffs if the player is in one
function QoreysBB:CheckVehicleStatus()
	playerUnit = UnitHasVehicleUI("player") and "vehicle" or "player"
	self:UNIT_AURA(nil, playerUnit)
end

-- Update group tables and such
function QoreysBB:UpdateGroups()
	for key in pairs(self.db.profile.groups) do
		if( not self.groups[key] ) then
			self.groups[key] = self:CreateGroup(key)
			self.groups[key].rows = {}
			self.auras[key] = {}
		end
	end
end

-- BAR MANAGEMENT
local function OnShow(self)
	local config = QoreysBB.db.profile.groups[self.name]
	
	-- Set the active anchor to the default one
	config.activeAnchor = config.anchorTo
	-- If debuffs are anchored to temp enchants, temp enchants to buffs
	-- We try and position debuffs, but temp enchants aren't visible, will automatically anchor the debuffs to buffs
	-- This also has the benefit of if buffs aren't shown, it'll automatically anchor debuffs where buffs are instead of temp enchants
	if( config.anchorTo ~= "" and not QoreysBB.groups[config.anchorTo]:IsVisible() and QoreysBB.db.profile.groups[config.anchorTo].anchorTo ~= "" ) then
		config.activeAnchor = QoreysBB.db.profile.groups[config.anchorTo].anchorTo
	end
	
	-- Check if we need to anchor it to something else
	if( config.activeAnchor ~= self.name and QoreysBB.groups[config.activeAnchor] ) then
		-- We're anchored to something else, and that anchor is visible
		if( QoreysBB.groups[config.activeAnchor]:IsVisible() ) then
			self:ClearAllPoints()
			if( QoreysBB.db.profile.groups[config.activeAnchor].growUp ) then
				self:SetPoint("TOPLEFT", QoreysBB.groups[config.activeAnchor].container, "TOPLEFT", 0, config.anchorSpacing)
			else
				self:SetPoint("TOPLEFT", QoreysBB.groups[config.activeAnchor].container, "BOTTOMLEFT", 0, -config.anchorSpacing)
			end

			self:SetMovable(false)
		else
			local scale = self:GetEffectiveScale()
			local position = QoreysBB.db.profile.groups[config.activeAnchor].position
			self:ClearAllPoints()
			self:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", position.x / scale, position.y / scale)
			self:SetMovable(true)
		end
		
	elseif( config.position ) then
		local scale = self:GetEffectiveScale()
		self:ClearAllPoints()
		self:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", config.position.x / scale, config.position.y / scale)
		self:SetMovable(true)
	else
		self:ClearAllPoints()
		self:SetPoint("CENTER", UIParent, "CENTER")
		self:SetMovable(true)
	end

	-- Check if something is anchored to us, if it is then we need to reposition them
	for name, data in pairs(QoreysBB.db.profile.groups) do
		if( data.anchorTo == self.name and self.name ~= name ) then
			OnShow(QoreysBB.groups[name])
		end
	end
end

-- Check if something is anchored to us, if it is then we need to reposition them
local function OnHide(self)
	for name, data in pairs(QoreysBB.db.profile.groups) do
		if( data.activeAnchor == self.name and QoreysBB.groups[name]:IsVisible() ) then
			OnShow(QoreysBB.groups[name])
		end
	end
end

local backdrop = {bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
		edgeFile = "Interface\\ChatFrame\\ChatFrameBackground", edgeSize = 0.80,
		insets = {left = 1, right = 1, top = 1, bottom = 1}}

function QoreysBB:CreateGroup(name)
	-- Set defaults
	local frame = CreateFrame("Frame", nil, UIParent)
	frame:SetMovable(true)
	frame:Hide()
	
	frame:SetScript("OnHide", OnHide)
	frame:SetScript("OnShow", OnShow)
	frame.name = name
	
	-- This is wrapped around all the bars so we can have things "linked" together
	frame.container = CreateFrame("Frame", nil, frame)
	return frame
end

-- Updates the actual positioning of things
local function updateBar(id, row, display, config)
	local texture = SML:Fetch(SML.MediaType.STATUSBAR, config.texture)
	row:SetWidth(config.width)
	row:SetHeight(config.height)
	row:SetStatusBarTexture(texture)
	row:Hide()
	
	row.bg:SetStatusBarTexture(texture)
	
	if( config.iconPosition == "LEFT" or config.iconPosition == "RIGHT" ) then
		row.icon:SetPoint("TOPLEFT", row, "TOP" .. config.iconPosition, display.iconPad, 0)
		row.icon:SetHeight(config.height)
		row.icon:SetWidth(config.height)
		row.icon:Show()
	else
		row.icon:Hide()
	end
	
	local font = SML:Fetch(SML.MediaType.FONT, config.font)
	if( not font ) then
		font = SML:Fetch(SML.MediaType.FONt, "Friz Quadrata TT") or (GameFontNormal:GetFont())
	end
	
	row.timer:SetFont(font, config.fontSize)
	row.timer:SetShadowOffset(1, -1)
	row.timer:SetShadowColor(0, 0, 0, 1)
	row.timer:SetHeight(config.height)
	
	row.text:SetFont(font, config.fontSize)
	row.text:SetShadowOffset(1, -1)
	row.text:SetShadowColor(0, 0, 0, 1)
	row.text:SetHeight(config.height)
	row.text:SetWidth(config.width - 40)
	
	row:ClearAllPoints()
	
	-- Position
	if( id > 1 ) then
		if( not config.growUp ) then
			row:SetPoint("TOPLEFT", display.rows[id - 1], "BOTTOMLEFT", 0, -config.spacing)
		else
			row:SetPoint("TOPLEFT", display.rows[id - 1], "TOPLEFT", 0, config.height + config.spacing)
		end
	elseif( config.growUp ) then
		row:SetPoint("BOTTOMLEFT", display, "TOPLEFT", display.barOffset, 0)
	else
		row:SetPoint("TOPLEFT", display, "BOTTOMLEFT", display.barOffset, 0)
	end
end

-- Reload everything in positioning and such
function QoreysBB:ReloadBars()
	for name, config in pairs(self.db.profile.groups) do
		local display = self.groups[name]
		display:SetWidth(config.width + config.height)
		display:SetHeight(config.height)
		display:SetScale(config.scale)
		display:SetAlpha(config.alpha)
						
		OnShow(display)

		if( config.iconPosition == "LEFT" ) then
			display.iconPad = -config.height
			display.barOffset = config.height
		else
			display.iconPad = 0
			display.barOffset = 0
		end
		
		-- Update bars
		for id, row in pairs(display.rows) do
			updateBar(id, row, display, config)
		end
		
		self:UpdateDisplay(name)
	end
end

-- Bar scripts
local function OnDragStart(self)
	if( not QoreysBB.db.profile.locked ) then
		local parent = self:GetParent()
		if( parent:IsMovable() ) then
			parent:StartMoving()
			parent.isMoving = true
		end
	end
end

local function OnDragStop(self)
	local parent = self:GetParent()
	if( parent.isMoving ) then
		parent:StopMovingOrSizing()
		parent.isMoving = nil

		local scale = parent:GetEffectiveScale()
		QoreysBB.db.profile.groups[parent.name].position = { x = parent:GetLeft() * scale, y = parent:GetTop() * scale }
	end
end

local function OnClick(self, mouseButton)
	if( mouseButton ~= "RightButton" or self.data.unit ~= "player" ) then
		return
	end
	
	if( self.type == "aura" ) then
		CancelUnitBuff("player", self.data.buffIndex, self.data.filter)
	elseif( self.type == "tempEnchants" ) then
		CancelItemTempEnchantment(self.data.slotID - 15)
	elseif( self.type == "tracking" ) then
		ToggleDropDownMenu(1, nil, MiniMapTrackingDropDown, self, 0, -5)
    elseif (self.type == "missing") then
         if (GetNumRaidMembers() > 0) then
            SendChatMessage("QoreysBuffBars: "..self.data.name, "RAID")
         elseif (GetNumPartyMembers() > 0) then
            SendChatMessage("QoreysBuffBars: "..self.data.name, "PARTY")
         end
	end
end

local function OnEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_BOTTOMLEFT")
	if( self.type == "aura" ) then
		GameTooltip:SetUnitAura(self.data.unit, self.data.buffIndex, self.data.filter)
	elseif( self.type == "tempEnchants" ) then
		GameTooltip:SetInventoryItem("player", self.data.slotID)
	elseif( self.type == "tracking" ) then
		GameTooltip:SetTracking()
	end
end

local function OnLeave(self)
	GameTooltip:Hide()
end

-- Grab a bar to use
function QoreysBB:CreateBar(parent)
	-- Create the actual bar
	local frame = CreateFrame("StatusBar", nil, parent)
	frame:EnableMouse(true)
	frame:SetClampedToScreen(true)
	frame:SetMovable(true)
	frame:RegisterForDrag("LeftButton")
	frame:SetScript("OnDragStart", OnDragStart)
	frame:SetScript("OnDragStop", OnDragStop)
	frame:SetScript("OnMouseUp", OnClick)
	frame:SetScript("OnEnter", OnEnter)
	frame:SetScript("OnLeave", OnLeave)
	frame:Hide()
	
	frame.bg = CreateFrame("StatusBar", nil, frame)
	frame.bg:SetMinMaxValues(0, 1)
	frame.bg:SetValue(1)
	frame.bg:SetAllPoints(frame)
	frame.bg:SetFrameLevel(0)
		
	-- Create icon
	frame.icon = frame:CreateTexture(nil, "ARTWORK")
	
	-- Icon border
	frame.iconBorder = frame:CreateTexture(nil, "OVERLAY")
	frame.iconBorder:SetPoint("TOPLEFT", frame.icon)
	frame.iconBorder:SetPoint("BOTTOMRIGHT", frame.icon)
	frame.iconBorder:Hide()
	
	-- Timer text
	frame.timer = frame:CreateFontString(nil, "OVERLAY")
	frame.timer:SetJustifyH("RIGHT")
	frame.timer:SetJustifyV("CENTER")
	frame.timer:SetPoint("TOPRIGHT", frame, "TOPRIGHT", -1, 0)
	
	-- Display Text
	frame.text = frame:CreateFontString(nil, "OVERLAY")
	frame.text:SetJustifyH("LEFT")
	frame.text:SetJustifyV("CENTER")
	frame.text:SetPoint("TOPLEFT", frame, "TOPLEFT", 2, 0)
	
	table.insert(parent.rows, frame)
	
	-- Update positioning
	updateBar(#(parent.rows), frame, parent, self.db.profile.groups[parent.name])
end

local formatTime = {
	["hhmmss"] = function(text, timeLeft)
		local hours, minutes, seconds = 0, 0, 0
		if( timeLeft >= 3600 ) then
			hours = floor(timeLeft / 3600)
			timeLeft = mod(timeLeft, 3600)
		end

		if( timeLeft >= 60 ) then
			minutes = floor(timeLeft / 60)
			timeLeft = mod(timeLeft, 60)
		end

		seconds = timeLeft > 0 and timeLeft or 0

		if( hours > 0 ) then
			text:SetFormattedText("%d:%02d:%02d", hours, minutes, seconds)
		else
			text:SetFormattedText("%02d:%02d", minutes > 0 and minutes or 0, seconds)
		end
	end,
	["blizzard"] = function(text, timeLeft)
		local hours, minutes, seconds = 0, 0, 0
		if( timeLeft >= 3600 ) then
			hours = floor(timeLeft / 3600)
			timeLeft = mod(timeLeft, 3600)
		end

		if( timeLeft >= 60 ) then
			minutes = floor(timeLeft / 60)
			timeLeft = mod(timeLeft, 60)
		end

		if( hours > 0 ) then
			text:SetFormattedText("%dh%dm", hours, minutes)
		elseif( minutes > 0 ) then
			text:SetFormattedText("%dm", minutes)
		else
			text:SetFormattedText("%ds", timeLeft > 0 and timeLeft or 0)
		end
	end,
}

-- Update visuals
local function OnUpdate(self)
	-- Time left
	local time = GetTime()
	self.secondsLeft = self.secondsLeft - (time - self.lastUpdate)
	self.lastUpdate = time
	
	self:SetValue(self.secondsLeft)
	
	formatTime[self.timeOption](self.timer, self.secondsLeft)
end

-- Update a single row
local buffTypes = {
	buff = {r = 0.30, g = 0.50, b = 1.0},
}

-- Setup a temporary table we can toss everything into
local tempRows = {}

--Q I modified this function for the expanded colors
local function updateRow(row, config, data)
	-- Set name/rank
	
	if( data.rank and data.stack and data.stack > 1 and config.showRank and config.showStack ) then
		if( not config.stackFirst ) then
			row.text:SetFormattedText("%s %s (%s)", data.name, data.rank, data.stack)
		else
			row.text:SetFormattedText("[%s] %s %s", data.stack, data.name, data.rank)
		end
	elseif( data.rank and config.showRank ) then
		row.text:SetFormattedText("%s %s", data.name, data.rank)
	elseif( data.stack and data.stack > 1 and config.showStack ) then
		if( not config.stackFirst ) then
			row.text:SetFormattedText("%s (%s)", data.name, data.stack)
		else
			row.text:SetFormattedText("[%s] %s", data.stack, data.name)
		end
	else
		row.text:SetText(data.name)
	end
		
	-- Set icon
	row.icon:SetWidth(config.height)
	row.icon:SetHeight(config.height)
	row.icon:SetTexture(data.icon)
	row.icon:Show()
	
	local color
	if( data.filter == "HARMFUL" ) then
        color = not config.colorByType and config.color or DebuffTypeColor[data.buffType] or DebuffTypeColor.none
        color.a=0.8
		color.a2=0.3
		row.iconBorder:SetTexture("Interface\\Buttons\\UI-Debuff-Overlays")
		row.iconBorder:SetTexCoord(0.296875, 0.5703125, 0, 0.515625)
		row.iconBorder:SetVertexColor(color.r, color.g, color.b)
		row.iconBorder:Show()
	elseif( data.type == "tempEnchants" ) then

        color = config.tempColor
		color.a=0.8
		color.a2=0.3
		row.iconBorder:SetTexCoord(0, 0, 0, 0)
		row.iconBorder:SetTexture("Interface\\Buttons\\UI-TempEnchant-Border")
		row.iconBorder:Show()
	elseif( data.type == "tracking" and data.trackingType ~= "spell" ) then
		color=config.TrackingHealingcolor
        color.a=0.8
		color.a2=0.3
		row.iconBorder:SetTexture("Interface\\Buttons\\UI-Debuff-Overlays")
		row.iconBorder:SetTexCoord(0.296875, 0.5703125, 0, 0.515625)
		row.iconBorder:SetVertexColor(0.81, 0.81, 0.81)
		row.iconBorder:Show()
	elseif( config.colorByType ) then
		color = buffTypes.buff
		color.a=0.8
		color.a2=0.3
        if ((StandardBuffs[data.name]) or (MountBuffs[data.name])) then
            color=config.color
            color.a=0.8
            color.a2=0.3
        elseif (ImportantBuffs[data.name]) then
            color=config.Importantcolor
            color.a=0.8
            color.a2=0.3
        elseif (ProcBuffs[data.name]) then
            color=config.Proccolor
            color.a=0.8
            color.a2=0.3
        elseif (TrackingBuffs[data.name]) then
            color=config.TrackingHealingcolor
            color.a=0.8
            color.a2=0.3
        elseif (BossBuffs[data.name]) then
            color=config.Bosscolor;
            color.a=0.8
            color.a2=0.3
        elseif (MissingBuffList[data.name]) then
            color=config.color
            color.a=1.0
            color.a2=1.0
        elseif (ClassSpecificBuffs[data.name]) then
            color=config.ClassSpecificcolor
            color.a=0.8
            color.a2=0.3
        else
            color.r = 0.5
            color.b = 0.5
            color.g = 0.5
            color.a = 0.8
            color.a2 = 0.3
            Print("[ADD THIS BUFF] Name: '"..data.name.."'")
        end
		row.iconBorder:Hide()
	else
		color = config.color
		color.a=0.8
        color.a2=0.3
        row.iconBorder:Hide()
	end
	
	-- Color bar by the debuff type
	if( color ) then
        row:SetStatusBarColor(color.r, color.g, color.b, color.a)
        if (config.BackgroundAlphaWhite) then
            row.bg:SetStatusBarColor(1,1,1, color.a2)
        else
            row.bg:SetStatusBarColor(color.r, color.g, color.b, color.a2)
        end
    else
    
    end

	-- Setup for sorting
	local time = GetTime()
	row.enabled = true
	row.type = data.type
	row.data = data
	row.timeOption = config.time
		
	-- Don't use an on update if it has no timer
	if( not data.untilCancelled ) then
		row.endTime = data.endTime or 0
		row.secondsLeft = row.endTime - time
		row.lastUpdate = time
		row.barWidth = config.width

		row:SetMinMaxValues(0, data.startSeconds)
		row:SetScript("OnUpdate", OnUpdate)
		row.timer:SetHeight(config.height)
		row.timer:Show()
		
		-- Do an initial timer update, this way we can get a valid timer text width
		OnUpdate(row)
		row.text:SetWidth(config.width - row.timer:GetWidth() - 5)
	else
		row:SetScript("OnUpdate", nil)
		row:SetMinMaxValues(0, 1)
		row:SetValue(config.fillTimeless and 1 or 0)
		row.text:SetWidth(config.width)
		row.timer:Hide()
	end
end

-- This is fairly ugly, I'm not exactly sure how I want to clean it up yet.
-- I think I'll go with some sort of single index I can sort by, and manipulate that based on setting
-- In fact, maybe I should turn this into a loadstring so I don't have to repeat the code, that also means
-- I don't have to load the functions when you probably won't need them 
--Q I modified this function to include sorting the specific buff colors together.
local sorting = {
	["timeleft"] = function(a, b)
		 if( not b or not a.enabled ) then
			return false
		 elseif( not b.enabled ) then
			return true
		 end
		
		 if( a.type == "tracking" ) then
			return true
		 elseif( b.type == "tracking" ) then
			return false
		 end
		 if (ClassSpecificBuffs[a.name] and ClassSpecificBuffs[b.name]) then
            return a.endTime > b.endTime
         elseif (ClassSpecificBuffs[a.name]) then 
            return false;
         elseif (ClassSpecificBuffs[b.name]) then
            return true;
         end
         if (BossBuffs[a.name] and BossBuffs[b.name]) then
            return a.endTime > b.endTime
         elseif(BossBuffs[a.name]) then
            return false
         elseif(BossBuffs[b.name]) then
            return true
         end
         if (ImportantBuffs[a.name] and ImportantBuffs[b.name]) then
            return a.endTime > b.endTime
         elseif (ImportantBuffs[a.name]) then
            return false
         elseif (ImportantBuffs[b.name]) then
            return true
         end
         if (TrackingBuffs[a.name] and TrackingBuffs[b.name]) then
            return a.endTime > b.endTime
         elseif (TrackingBuffs[a.name]) then
            return false
         elseif (TrackingBuffs[b.name]) then
            return true
         end
         
		if( a.untilCancelled and b.untilCancelled ) then
			return a.name < b.name
		elseif( a.untilCancelled ) then
			return true
		elseif( b.untilCancelled ) then
			return false
		end

		if( a.type == "tempEnchants" and b.type == "tempEnchants" ) then
			return a.slotID < b.slotID
		elseif( a.type == "tempEnchants" ) then
			return true
		elseif( b.type == "tempEnchants" ) then
			return false
		end
		
		return a.endTime > b.endTime

	end,
	["index"] = function(a, b)
		if( not b or not a.enabled ) then
			return false
		elseif( not b.enabled ) then
			return true
		end
		
		if( a.type == "tracking" ) then
			return true
		elseif( b.type == "tracking" ) then
			return false
		end
		
		if( a.type == "tempEnchants" and b.type == "tempEnchants" ) then
			return a.slotID < b.slotID
		elseif( a.type == "tempEnchants" ) then
			return true
		elseif( b.type == "tempEnchants" ) then
			return false
		end
		
		return a.buffIndex < b.buffIndex
	end,
}

-- Update display for the passed time
--Q Changed this buffmod to include if (displayID=="buffs") then UpdateMissingBuffs also
function QoreysBB:UpdateDisplay(displayID)
	local display = self.groups[displayID]
	local buffs = self.auras[displayID]
	local config = self.db.profile.groups[displayID]

	-- Anchor disabled
	if( not self.db.profile.groups[displayID].enabled ) then
		display:Hide()
		
		for _, row in pairs(display.rows) do
			row:Hide()
		end
		return
	end

	-- Clear table
	for i=#(tempRows), 1, -1 do
		table.remove(tempRows, i)
	end
	
	-- Create auras
	for id, data in pairs(self.auras[displayID]) do
		if( data.enabled ) then
			table.insert(tempRows, data)
		end
	end
    
	-- Nothing to show
	if( #(tempRows) == 0 ) then
		display:Hide()
		return
	elseif( #(tempRows) > #(display.rows) ) then
		for id in pairs(tempRows) do
			if( not display.rows[id] ) then
				self:CreateBar(display)
			end
		end
	end

	display:Show()

	table.sort(tempRows, sorting[config.sortBy])
	
	-- Position
	local lastRow = 0
	for id, row in pairs(display.rows) do
		local buff = tempRows[id]
		if( buff and buff.enabled and id <= config.maxRows ) then
			updateRow(row, config, buff)
			lastRow = id
			row:Show()
		else
			row:Hide()
		end
	end
	
	-- Setup the container frame to wrap around it, so we can position other groups to it (if needed)
	if( display.rows[1] and display.rows[1]:IsVisible() ) then
		display.container:ClearAllPoints()
		
		-- When grow up, it goes from # -> 1, when not it's 1 -> #
		local firstRow = 1
		if( config.growUp ) then
			firstRow = lastRow
			lastRow = 1
		end
		
		-- Update frame size based on rows used
		if( config.iconPosition == "LEFT" ) then
			display.container:SetPoint("TOPLEFT", display.rows[firstRow].icon)
			display.container:SetPoint("BOTTOMRIGHT", display.rows[lastRow])
		elseif( config.iconPosition == "RIGHT" ) then
			display.container:SetPoint("TOPLEFT", display.rows[firstRow])
			display.container:SetPoint("BOTTOMRIGHT", display.rows[lastRow].icon)
		else
			display.container:SetPoint("TOPLEFT", display.rows[firstRow])
			display.container:SetPoint("BOTTOMRIGHT", display.rows[lastRow])
		end
	end
end

-- Update auras
function QoreysBB:UpdateAuras(group, unit, filter)
	for _, data in pairs(self.auras[group]) do if( not data.ignore ) then data.enabled = nil data.untilCancelled = nil data.type = nil end end
		
	local config = self.db.profile.groups[group]
	local time = GetTime()
	local buffID = 1
	-- We reserve the first three indexes for special buffs
	local tableID = 4
	
	while( true ) do
		local name, rank, texture, count, debuffType, duration, endTime, caster, isStealable = UnitAura(unit, buffID, filter)
		if( not name ) then break end
		
		-- Check if it's filtered
		if( ( not config.playerOnly or config.playerOnly and caster == "player" ) and ( not config.passive or config.passive and duration > 0 and endTime > 0 ) and ( not config.canFilter or not self.modules.Filters:IsFiltered(name) ) ) then			local buff = self.auras[group][tableID]
			if( not buff ) then
				self.auras[group][tableID] = {}
				buff = self.auras[group][tableID]
			end
			
			buff.enabled = true
			buff.type = "aura"
			buff.unit = unit
			buff.buffIndex = buffID
			buff.untilCancelled = duration == 0 and endTime == 0
			buff.icon = texture
			buff.buffType = debuffType
			buff.stack = count or 0
			buff.filter = filter
			buff.startSeconds = duration
			buff.endTime = endTime
			buff.name = name
			buff.rank = tonumber(string.match(rank, "(%d+)"))

			-- Grab the next table index now
			tableID = tableID + 1
		end

		buffID = buffID + 1
	end
end

-- Update player buff/debuffs
function QoreysBB:UNIT_AURA(event, unit)
    if( unit ~= playerUnit ) then
	return
    end
    self:UpdateAuras("buffs", unit, "HELPFUL")
    self:UpdateDisplay("buffs")

    self:VerifyMissingBuffs()
    self:UpdateDisplay("missing")
    
    self:UpdateAuras("debuffs", unit, "HARMFUL")
    self:UpdateDisplay("debuffs")
end

-- Find an unused index that we can hijack
function QoreysBB:FindAvailableIndex(key, type)
	local foundIndex
	local lastIndex = 0
	--Q This fixes the temporary enchant bug hopefully?
    Print(tostring(key));
    if (self.auras[key]==nil) then 
        self.auras[key] = {}
        self.auras[key][0] = {}
        return 0 
    end
    
    for index, buff in pairs(self.auras[key]) do
		if( buff.ignore ) then
			lastIndex = index
		end
		
		if( not buff.enabled and buff.type == type ) then
			foundIndex = index
			break
		end
	end
	
	-- None was created yet, so will make our own
	if( not foundIndex ) then
		lastIndex = lastIndex + 1
		self.auras[key][lastIndex] = {}
		return lastIndex
	end
	
	-- Return a created one
	return foundIndex
end

-- Update the players current tracked thing
function QoreysBB:UpdateTracking()
	if( not self.db.profile.showTrack ) then
		return
	end
	
	-- This prevents us from needing to search for our table every single time
	TRACKING_INDEX = TRACKING_INDEX or self:FindAvailableIndex("buffs", "tracking")
			
	-- Reset it to default in case we don't find anything
	local buff = self.auras.buffs[TRACKING_INDEX]
	buff.enabled = true
	buff.ignore = true
	buff.type = "tracking"
	buff.unit = "player"
	buff.name = L["None"]
	buff.icon = GetTrackingTexture()
	buff.trackingType = nil
	buff.untilCancelled = true
	
	-- Search for active track
	for i=1, GetNumTrackingTypes() do
		local name, icon, active, type = GetTrackingInfo(i)
		if( active ) then
			buff.name = name
			buff.icon = icon
			buff.trackingType = type
		end
	end
	
	self:UpdateDisplay("buffs")
end

-- Parse out name/rank from a temp weapon buff
function QoreysBB:ParseName(slotID)
	if( not self.tooltip ) then
		self.tooltip = CreateFrame("GameTooltip", "QoreysBBTooltip", UIParent, "GameTooltipTemplate")
		self.tooltip:SetOwner(UIParent, "ANCHOR_NONE")
	end
	
	self.tooltip:SetInventoryItem("player", slotID)
	
	for i=1, self.tooltip:NumLines() do
		local text = _G["QoreysBBTooltipTextLeft" .. i]:GetText()
		local name = string.match(text, "^(.+) %(%d+[^%)]+%)$")
		if( name ) then
			-- Strip any remaining brackets for things such as fishing which shows +100 Fishing as well
			name = string.gsub(name, " %(%d+[^%)]+%)", "")
			
			local tName, rank = string.match(name, "^(.*)(%w*)$")
			if( tName and rank ) then
				name = tName
			end
			
			return name, rank
		end
	end
	
	return nil, nil
end

-- Update temp weapon enchants
local tempStartTime = {}
function QoreysBB:UpdateTempEnchant(buff, slotID, hasEnchant, timeLeft, charges)
	if( not hasEnchant ) then
		buff.enabled = false
		return
	end
	
	local name, rank = self:ParseName(slotID)
	if( not name ) then
		buff.enabled = false
		return
	end

	timeLeft = timeLeft / 1000
	
	local enchantID = name .. (rank or "")
	
	-- Record the highest start time for the temp enchant
	if( not tempStartTime[enchantID] or tempStartTime[enchantID] < timeLeft ) then
		tempStartTime[enchantID] = timeLeft
	end	
	
	buff.enabled = true
	buff.ignore = true
	buff.type = "tempEnchants"
	buff.slotID = slotID
	buff.unit = "player"
	buff.name = name
	buff.rank = rank

	buff.timeLeft = timeLeft
	buff.endTime = GetTime() + timeLeft
	buff.startSeconds = tempStartTime[enchantID]

	buff.icon = GetInventoryItemTexture("player", slotID)
	buff.stack = charges or 0
end

function QoreysBB:PLAYER_ENTERING_WORLD()
	self:RegisterEvent("UNIT_AURA")
	self:RegisterEvent("UNIT_ENTERED_VEHICLE", "CheckVehicleStatus")
	self:RegisterEvent("UNIT_EXITED_VEHICLE", "CheckVehicleStatus")
	self:RegisterEvent("MINIMAP_UPDATE_TRACKING", "UpdateTracking")
	self:RegisterEvent("PARTY_MEMBERS_CHANGED", "PartyChanged")
	self:RegisterEvent("RAID_ROSTER_UPDATE", "RaidChanged")

	self:UnregisterEvent("PLAYER_ENTERING_WORLD")
	
	-- Fixes Track Humanoids not being changed correctly
	if( select(2, UnitClass("player")) == "DRUID" ) then
		self:RegisterEvent("UPDATE_SHAPESHIFT_FORM", "UpdateTracking")
	end
	
	-- Update visuals
	self:ReloadBars()
	
	-- Show temp buffs? Show our timer frame then
	if( self.db.profile.showTemp ) then
		frame:Show()
	else
		frame:Hide()
	end
	
	-- Update buffs
	self:CheckVehicleStatus()
	self:UNIT_AURA(nil, playerUnit)
	self:UpdateTracking()
end

-- Update temp weapons
local timeElapsed = 0
local mainHand, offHand = {time = 0}, {time = 0}
frame:SetScript("OnUpdate", function(self, elapsed)
	timeElapsed = timeElapsed + elapsed
	
	if( timeElapsed < 0.50 ) then
		return
	end
	
	timeElapsed = 0
	self = QoreysBB

	local hasMain, mainTimeLeft, mainCharges, hasOff, offTimeLeft, offCharges = GetWeaponEnchantInfo()
	local updated
	
	-- Update main hand if it's changed
	mainTimeLeft = mainTimeLeft or 0
	if( hasMain ~= mainHand.has or mainTimeLeft > mainHand.time or mainHand.charges ~= mainCharges ) then
		updated = true
        MAINHAND_BUFF_INDEX = MAINHAND_BUFF_INDEX or self:FindAvailableIndex(ENCHANT_ANCHOR, "tempEnchants")
		self:UpdateTempEnchant(self.auras[ENCHANT_ANCHOR][MAINHAND_BUFF_INDEX], MAINHAND_SLOT, hasMain, mainTimeLeft, mainCharges)
	end
	
	mainHand.has = hasMain
	mainHand.time = mainTimeLeft
	mainHand.charges = mainCharges

	-- Update off hand if it's changed
	offTimeLeft = offTimeLeft or 0
	if( hasOff ~= offHand.has or offTimeLeft > offHand.time or offHand.charges ~= offCharges ) then
		updated = true
		OFFHAND_BUFF_INDEX = OFFHAND_BUFF_INDEX or self:FindAvailableIndex(ENCHANT_ANCHOR, "tempEnchants")
		self:UpdateTempEnchant(self.auras[ENCHANT_ANCHOR][OFFHAND_BUFF_INDEX], OFFHAND_SLOT, hasOff, offTimeLeft, offCharges)
	end
	
	offHand.has = hasOff
	offHand.time = offTimeLeft
	offHand.charges = offCharges
	
	-- Update if needed
	if( updated ) then
		QoreysBB:UpdateDisplay(ENCHANT_ANCHOR)
	end
end)

-- If we want a texture that was registered later after we loaded, reload the bars so it uses the correct one
function QoreysBB:ResourceRegistered(event, mediaType, key)
	if( mediaType == SML.MediaType.STATUSBAR or mediaType == SML.MediaType.FONT ) then
		for name, config in pairs(self.db.profile.groups) do
			if( config.texture == key or config.font == key ) then
				self:ReloadBars()
				return
			end
		end
	end
end

-- Configuration changed, update bars
local examplesShown
function QoreysBB:Reload()
	-- Example buffs
	if( self.db.profile.showExample and not examplesShown ) then
		examplesShown = true
		
		for key, group in pairs(self.db.profile.groups) do
			if( group.enabled ) then
				local index = self:FindAvailableIndex(key, "example")
				local buff = self.auras[key][index]
				
				buff.enabled = true
				buff.ignore = true
				buff.type = "example"
				buff.name = group.name
				buff.icon = "Interface\\Icons\\Spell_Nature_RemoveCurse"
				buff.stack = 3
				buff.rank = 2
				buff.timeLeft = 635
				buff.startSeconds = 700
				buff.endTime = GetTime() + buff.timeLeft
			end
		end
	-- Disable example buffs
	elseif( not self.db.profile.showExample and examplesShown ) then
		examplesShown = nil
		
		for key, group in pairs(self.db.profile.groups) do
			for _, buff in pairs(self.auras[key]) do
				if( buff.type == "example" ) then
					buff.enabled = false
				end
			end
		end
	end

	-- Hide the tracking info
	if( not self.db.profile.showTrack and TRACKING_INDEX ) then
		self.auras.buffs[TRACKING_INDEX].enabled = false
	end
	
	-- Force it to find the temp enchant indexes again in case it moved anchors
	if( MAINHAND_BUFF_INDEX ) then
		self.auras[ENCHANT_ANCHOR][MAINHAND_BUFF_INDEX].enabled = false
		self.auras[ENCHANT_ANCHOR][MAINHAND_BUFF_INDEX].ignore = false

		MAINHAND_BUFF_INDEX = nil
	end
	
	if( OFFHAND_BUFF_INDEX ) then
		self.auras[ENCHANT_ANCHOR][OFFHAND_BUFF_INDEX].enabled = false
		self.auras[ENCHANT_ANCHOR][OFFHAND_BUFF_INDEX].ignore = false

		OFFHAND_BUFF_INDEX = nil
	end
	
	-- Update temporary enchants
	if( not self.db.profile.showTemp ) then
		frame:Hide()
	else
		frame:Show()
		
		mainHand = {time = 0}
		offHand = {time = 0}
	end

	-- Check if we should swap the enchant anchor to something else
	if( self.db.profile.groups.tempEnchants.moveTo ~= "" ) then
		ENCHANT_ANCHOR = self.db.profile.groups.tempEnchants.moveTo
	else
		ENCHANT_ANCHOR = "tempEnchants"
	end
	
	-- Full bar update
	self:ReloadBars()
	self.modules.Filters:Reload()
	self.modules.Extras:Reload()
	self:UNIT_AURA(nil, playerUnit)
	self:UpdateTracking()
	self:UpdateDisplay("tempEnchants")
end


-- Qorey's additions

function QoreysBB:Print(msg)
	DEFAULT_CHAT_FRAME:AddMessage("|cff33ff99Qoreys Buff Bars|r: " .. msg)
end

function Print(s)
	if (QBBDebug) then
		QoreysBB:Print(s)
	end
end

function QoreysBB:DisableMissingBuffs()
    
	for _, buff in pairs(self.auras["missing"]) do
		buff.enabled = false
	end
	self:ClearMissingBuffsIndex()
end

function QoreysBB:ClearMissingBuffsIndex()
    wipe(MissingBuffs)

    MissingBuffs = {
    ["Arcane Intellect"]=-1,
    ["Mark of the Wild"]=-1,
    ["Blessing of Wisdom"]=-1,
    ["Blessing of Might"]=-1,
    ["Blessing of Kings"]=-1,
    ["Blessing of Sanctuary"]=-1,
    ["Power Word: Fortitude"]=-1,
    ["Divine Spirit"]=-1,
    ["Shadow Protection"]=-1,
    ["Well Fed"]=-1,
    ["Flask of <...>"]=-1
    }

end
function QoreysBB:UpdateCurrentBuffs()
	wipe(CurrentBuffs)
	local buffID = 1
	while( true ) do
		local name, rank, texture, count, debuffType, duration, endTime, caster, isStealable = UnitAura("player", buffID, "HELPFUL")
		if( not name ) then break end
        tableIndex=0
        CurrentBuffs[name]=true;
		buffID = buffID + 1
	end
    
    local tableIndex=1
    --Print(tostring(self.auras["buffs"][tableIndex]))
    while (self.auras["buffs"][tableIndex] ~= nil) do            
        local buff=self.auras["buffs"][tableIndex]
        --Print("self.auras["..tableIndex.."] - "..buff.name.." - ignore="..tostring(buff.ignore).." - enabled="..tostring(buff.enabled))
        tableIndex = tableIndex+1
    end
end

function Spec(class) 
	if (class == "SHAMAN") then
		if (select(3,GetTalentTabInfo(1)) > 40) then
				return "MELEEDPS"
		elseif (select(3,GetTalentTabInfo(2)) > 40) then
			return "CASTERDPS"
		else
			return "HEALER"
		end
	elseif (class == "DEATHKNIGHT" or class == "WARRIOR" or class == "ROGUE" or class == "HUNTER") then
		return "MELEEDPS"
	elseif (class == "PRIEST") then
		if (select(3,GetTalentTabInfo(1)) > 40) or (select(3,GetTalentTabInfo(2)) > 40) then
			return "HEALER"
		else
			return "CASTERDPS"
		end
	elseif (class == "PALADIN") then
		if (select(3,GetTalentTabInfo(1)) > 40) then
			return "HEALER"
		else
			return "MELEEDPS"
		end
	elseif (class == "MAGE" or class == "WARLOCK") then
		return "CASTERDPS"
	elseif (class == "DRUID") then
		if (select(3,GetTalentTabInfo(1)) > 40) then
			return "CASTERDPS"
		elseif (select(3,GetTalentTabInfo(2)) > 40) then
			return "MELEEDPS"
		else
			return "HEALER"
		end
	end
    return "UNKNOWN"
end

function QoreysBB:VerifyMissingBuffs()
   local playerClass, englishClass = UnitClass("player");
   local key = "missing"
   self:UpdateClasses()
   self:UpdateCurrentBuffs()

    local PlayerSpec = {}
    if (UnitHasVehicleUI("player")) then
        --Print("Disable missing buffs, i'm in a vehicle!")
        self:DisableMissingBuffs()
    else
	local inInstance, instanceType=IsInInstance()

	if (inInstance and instanceType=="raid") then
		if (CurrentBuffs["Well Fed"] == nil) then
			if (MissingBuffs["Well Fed"] == nil or (MissingBuffs["Well Fed"] == -1)) then
			
				MissingBuffs["Well Fed"] = self:FindAvailableIndex(key,"missing")
				--Print("[Missing Buff: Well Fed] Index:"..MissingBuffs["Well Fed"])
				local buff = self.auras[key][MissingBuffs["Well Fed"]]
				buff.enabled = true
				buff.ignore = true
				buff.type = "missing"
				buff.name = "Missing: Well Fed"
				buff.icon = "Interface\\Icons\\INV_Misc_Food_37"
				buff.stack = 0
				buff.rank = 0
				buff.untilCancelled = true
				buff.unit="player"
				buff.filter="HELPFUL"
				--verify if one of these are already included in the missing buffs
			end
		
		elseif (MissingBuffs["Well Fed"] > -1) then
			local buff=self.auras[key][MissingBuffs["Well Fed"]]
			buff.enabled=false;
			buff.ignore=false;
			--Print("[Removed Buff: Well Fed] Index:"..MissingBuffs["Well Fed"])
			MissingBuffs["Well Fed"] = -1;
		end
		if (CurrentBuffs["Flask of Stoneblood"]==nil and CurrentBuffs["Flask of Endless Rage"]==nil and CurrentBuffs["Flask of Pure Mojo"]==nil and 
			CurrentBuffs["Flask of the Frost Wyrm"]==nil and CurrentBuffs["Flask of Distilled Wisdom"]==nil) then
			if (MissingBuffs["Flask of <...>"] == nil or (MissingBuffs["Flask of <...>"] == -1)) then
				MissingBuffs["Flask of <...>"] = self:FindAvailableIndex(key,"missing")
				--Print("[Missing Buff: Flask of <...>] Index:"..MissingBuffs["Flask of <...>"])
				local buff = self.auras[key][MissingBuffs["Flask of <...>"]]
				buff.enabled = true
				buff.ignore = true
				buff.type = "missing"
				if (Spec(englishClass) == "CASTERDPS") then
					buff.name = "Missing: Flask of the Frost Wyrm"
				elseif (Spec(englishClass) == "HEALER") then
					buff.name = "Missing: Flask of Pure Mojo/Distilled Wisdom"
				elseif (englishClass == "DRUID" or englishClass == "WARRIOR" or englishClass == "PALADIN" or englishClass == "DEATHKNIGHT") then
					buff.name = "Missing: Flask of Stoneblood/Endless Rage"
				else
					buff.name = "Missing: Flask of Endless Rage"
				end
				buff.icon = "Interface\\Icons\\INV_Potion_21"
				buff.stack = 0
				buff.rank = 0
				buff.untilCancelled = true
				buff.unit="player"
				buff.filter="HELPFUL"
				--verify if one of these are already included in the missing buffs
			end
		
		elseif (MissingBuffs["Flask of <...>"] > -1) then
			local buff=self.auras[key][MissingBuffs["Flask of <...>"]]
			buff.enabled=false;
			buff.ignore=false;
			--Print("[Removed Buff: Flask of <...>] Index:"..MissingBuffs["Flask of <...>"])
			MissingBuffs["Flask of <...>"] = -1;
		end
	else
		if (MissingBuffs["Well Fed"] > -1) then
			local buff=self.auras[key][MissingBuffs["Well Fed"]]
			buff.enabled=false;
			buff.ignore=false;
			--Print("[Removed Buff: Well Fed] Index:"..MissingBuffs["Well Fed"])
			MissingBuffs["Well Fed"] = -1;
		end
		if (MissingBuffs["Flask of <...>"] > -1) then
			local buff=self.auras[key][MissingBuffs["Flask of <...>"]]
			buff.enabled=false;
			buff.ignore=false;
			--Print("[Removed Buff: Flask of <...>] Index:"..MissingBuffs["Flask of <...>"])
			MissingBuffs["Flask of <...>"] = -1;
		end
	end
	if ((englishClass ~= "DEATHKNIGHT") and (englishClass ~= "ROGUE") and (englishClass ~= "WARRIOR")) then
  		if (((CurrentBuffs["Arcane Intellect"] == nil  and  CurrentBuffs["Arcane Brilliance"] == nil and  CurrentBuffs["Dalaran Brilliance"] == nil) and CurrentBuffs["Dalaran Intellect"] == nil) and (Classes["MAGE"])) then 
			if (MissingBuffs["Arcane Intellect"] == nil or (MissingBuffs["Arcane Intellect"] == -1)) then
				
				MissingBuffs["Arcane Intellect"] = self:FindAvailableIndex(key,"missing")
				--Print("[Missing Buff: Arcane Intellect] Index:"..MissingBuffs["Arcane Intellect"])
				local buff = self.auras[key][MissingBuffs["Arcane Intellect"]]
				buff.enabled = true
				buff.ignore = true
				buff.type = "missing"
				buff.name = "Missing: Arcane Intellect"
				buff.icon = "Interface\\Icons\\Spell_Holy_MagicalSentry"
				buff.stack = 0
				buff.rank = 0
				buff.untilCancelled = true
				buff.unit="player"
				buff.filter="HELPFUL"
				--verify if one of these are already included in the missing buffs
			end
		elseif (MissingBuffs and (MissingBuffs["Arcane Intellect"] > -1)) then
			local buff=self.auras[key][MissingBuffs["Arcane Intellect"]]
			buff.enabled=false;
			buff.ignore=false;
			--Print("[Removed Buff: Arcane Intellect] Index:"..MissingBuffs["Arcane Intellect"])
			MissingBuffs["Arcane Intellect"] = -1;
		end
	end
	
	if ((CurrentBuffs["Mark of the Wild"] == nil and CurrentBuffs["Gift of the Wild"] == nil) and (Classes["DRUID"])) then 
		if (MissingBuffs["Mark of the Wild"] == nil or (MissingBuffs["Mark of the Wild"] == -1)) then
			MissingBuffs["Mark of the Wild"] = self:FindAvailableIndex(key,"missing");
			--Print("[Missing Buff: Mark/Gift of the Wild] Index: "..MissingBuffs["Mark of the Wild"])
			local buff = self.auras[key][MissingBuffs["Mark of the Wild"]]				
			buff.enabled = true
			buff.ignore = true
			buff.unit="player"			buff.type = "missing"
			buff.name = "Missing: Mark of the Wild"
			buff.icon = "Interface\\Icons\\Spell_Nature_Regeneration"
			buff.stack = 0
			buff.rank = 0
			buff.untilCancelled = true
			buff.filter="HELPFUL"
		end
	elseif ((MissingBuffs ~= nil) and (MissingBuffs["Mark of the Wild"] > -1)) then
		local buff=self.auras[key][MissingBuffs["Mark of the Wild"]]
		buff.enabled=false;
		buff.ignore=false;
		 --Print("[Removed Buff: Mark of the Wild] Index:"..MissingBuffs["Mark of the Wild"])
		MissingBuffs["Mark of the Wild"] = -1;
	end
	
	if (Classes["PALADIN"]) then
		--Print("Did you know - there is a paladin in your party??")
	        if ((CurrentBuffs["Blessing of Kings"] == nil and CurrentBuffs["Greater Blessing of Kings"] == nil)) then 
       			if (MissingBuffs["Blessing of Kings"] == nil or (MissingBuffs["Blessing of Kings"] == -1)) then
        		        MissingBuffs["Blessing of Kings"] = self:FindAvailableIndex(key,"missing");
                		Print("[Missing Buff: Blessing of Kings] Index: "..MissingBuffs["Blessing of Kings"])
               			local buff = self.auras[key][MissingBuffs["Blessing of Kings"]]				
               	 		buff.enabled = true
               	 		buff.ignore = true
               		 	buff.type = "missing"
               	 		buff.name = "Missing: Blessing of Kings"
               		 	buff.icon = "Interface\\Icons\\Spell_Magic_GreaterBlessingofKings"
                		buff.stack = 0
                		buff.rank = 0
                		buff.untilCancelled = true
                        	buff.unit="player"
                		buff.filter="HELPFUL"
                	--verify if one of these are already included in the missing buffs
     		       	end
        	elseif (MissingBuffs and (MissingBuffs["Blessing of Kings"] > -1)) then
        	    local buff=self.auras[key][MissingBuffs["Blessing of Kings"]]
        	    buff.enabled=false;
        	    buff.ignore=false;
                --Print("[Removed Buff: Blessing of Kings] Index:"..MissingBuffs["Blessing of Kings"])
        	    MissingBuffs["Blessing of Kings"] = -1;
        	end

		--Print("Missing buff: Blessing of Might Start, spec: "..Spec(englishClass))
        	if ((englishClass ~= "MAGE") and (englishClass ~= "WARLOCK") and (englishClass ~= "PRIEST")) then
			if (Spec(englishClass)=="MELEEDPS") then
				if ((CurrentBuffs["Blessing of Might"] == nil and CurrentBuffs["Greater Blessing of Might"] == nil) and (Classes["PALADIN"])) then 
					if (MissingBuffs["Blessing of Might"] == nil or (MissingBuffs["Blessing of Might"] == -1)) then
						MissingBuffs["Blessing of Might"] = self:FindAvailableIndex(key,"missing");
						 --Print("[Missing Buff: Blessing of Might] Index: "..MissingBuffs["Blessing of Might"])
						local buff = self.auras[key][MissingBuffs["Blessing of Might"]]
						buff.enabled = true
						buff.ignore = true
						buff.type = "missing"
						buff.name = "Missing: Blessing of Might"
						buff.icon = "Interface\\Icons\\Spell_Holy_SealofWrath"
						buff.stack = 0
						buff.rank = 0
						buff.unit="player"
						buff.untilCancelled = true
						buff.filter="HELPFUL"
					end
					--verify if one of these are already included in the missing buffs			
				elseif (MissingBuffs and (MissingBuffs["Blessing of Might"] > -1)) then
					local buff=self.auras[key][MissingBuffs["Blessing of Might"]]
					buff.enabled=false;
					buff.ignore=false;
                    --Print("[Removed Buff: Blessing of Might] Index:"..MissingBuffs["Blessing of Might"])
					MissingBuffs["Blessing of Might"] = -1;
				end
			end
		end
		
		if ((englishClass ~= "ROGUE") and (englishClass ~= "WARRIOR") and (englishClass ~= "DEATHKNIGHT")) then
			if ((Spec(englishClass)=="CASTERDPS") or (Spec(englishClass)=="HEALER") or (englishClass=="PALADIN")) then
				if ((CurrentBuffs["Blessing of Wisdom"]== nil and CurrentBuffs["Greater Blessing of Wisdom"] == nil) and (Classes["PALADIN"])) then 
					if (MissingBuffs["Blessing of Wisdom"] == nil or (MissingBuffs["Blessing of Wisdom"] == -1)) then
						MissingBuffs["Blessing of Wisdom"] = self:FindAvailableIndex(key,"missing");
						 --Print("[Missing Buff: Blessing of Wisdom] Index: "..MissingBuffs["Blessing of Wisdom"])				
						local buff = self.auras[key][MissingBuffs["Blessing of Wisdom"]]
						buff.enabled = true
						buff.ignore = true
						buff.type = "missing"
						buff.name = "Missing: Blessing of Wisdom"
						buff.icon = "Interface\\Icons\\Spell_Holy_SealofWisdom"
						buff.stack = 0
						buff.unit="player"
						buff.rank = 0
						buff.untilCancelled = true
						buff.filter="HELPFUL"
					end
				--verify if one of these are already included in the missing buffs
				elseif (MissingBuffs and (MissingBuffs["Blessing of Wisdom"] > -1)) then
					local buff=self.auras[key][MissingBuffs["Blessing of Wisdom"]]
					buff.enabled=false;
					buff.ignore=false;
					--Print("[Removed Buff: Blessing of Wisdom] Index:"..MissingBuffs["Blessing of Wisdom"])
					MissingBuffs["Blessing of Wisdom"] = -1;
				end
			end
		end
		if ((englishClass == "DRUID") or (englishClass == "WARRIOR") or (englishClass == "DEATHKNIGHT") or (englishClass == "PALADIN")) then
			if (Spec(englishClass)=="MELEEDPS") then
				if ((CurrentBuffs["Blessing of Sanctuary"] == nil and  CurrentBuffs["Greater Blessing of Sanctuary"] == nil) and (Classes["PALADIN"])) then 
					if (MissingBuffs["Blessing of Sanctuary"] == nil or (MissingBuffs["Blessing of Sanctuary"] == -1)) then
						MissingBuffs["Blessing of Sanctuary"] = self:FindAvailableIndex(key,"missing");
						--Print("[Missing Buff: Blessing of Sanctuary] Index:"..MissingBuffs["Blessing of Sanctuary"])
						local buff = self.auras[key][MissingBuffs["Blessing of Sanctuary"]]
						buff.enabled = true
						buff.ignore = true
						buff.type = "missing"
						buff.unit="player"
						buff.name = "Missing: Blessing of Sanctuary"
						buff.icon = "Interface\\Icons\\Spell_Holy_ReviveChampion"
						buff.stack = 0
						buff.rank = 0
						buff.untilCancelled = true
						buff.filter="HELPFUL"
					end
				--verify if one of these are already included in the missing buffs
				elseif (MissingBuffs and (MissingBuffs["Blessing of Sanctuary"] > -1)) then
					local buff=self.auras[key][MissingBuffs["Blessing of Sanctuary"]]
					buff.enabled=false;
					buff.ignore=false;
                    --Print("[Removed Buff: Blessing of Sanctuary] Index:"..MissingBuffs["Blessing of Sanctuary"])
					MissingBuffs["Blessing of Sanctuary"] = -1;
				end
			end
		end
	else -- if (Classes["PALADIN"]) then
		if (MissingBuffs) then
			if (MissingBuffs["Blessing of Sanctuary"] > -1) then
				local buff=self.auras[key][MissingBuffs["Blessing of Sanctuary"]]
				buff.enabled=false;
				buff.ignore=false;
				--Print("[(No pallys)Removed Buff: Blessing of Sanctuary] Index:"..MissingBuffs["Blessing of Sanctuary"])
				MissingBuffs["Blessing of Sanctuary"] = -1;
			end
			if (MissingBuffs["Blessing of Wisdom"] > -1) then
				local buff=self.auras[key][MissingBuffs["Blessing of Wisdom"]]
				buff.enabled=false;
				buff.ignore=false;
				--Print("[(No pallys)Removed Buff: Blessing of Wisdom] Index:"..MissingBuffs["Blessing of Wisdom"])
				MissingBuffs["Blessing of Wisdom"] = -1;
			end
			if (MissingBuffs["Blessing of Might"] > -1) then
				local buff=self.auras[key][MissingBuffs["Blessing of Might"]]
				buff.enabled=false;
				buff.ignore=false;
				--Print("[(No pallys)Removed Buff: Blessing of Might] Index:"..MissingBuffs["Blessing of Might"])
				MissingBuffs["Blessing of Might"] = -1;
			end
		end
	end
	if (Classes["PRIEST"]) then
		if ((CurrentBuffs["Power Word: Fortitude"] == nil and CurrentBuffs["Prayer of Fortitude"] == nil)) then 
			if (MissingBuffs["Power Word: Fortitude"] == nil or (MissingBuffs["Power Word: Fortitude"] == -1)) then
				MissingBuffs["Power Word: Fortitude"] = self:FindAvailableIndex(key,"missing");
				 --Print("[Missing Buff: PW: Fortitude] Index:"..MissingBuffs["Power Word: Fortitude"])
				local buff = self.auras[key][MissingBuffs["Power Word: Fortitude"]]
				buff.enabled = true
				buff.ignore = true
				buff.type = "missing"
				buff.name = "Missing: Power Word: Fortitude"
				buff.icon = "Interface\\Icons\\Spell_Holy_WordFortitude"
				buff.stack = 0
				buff.unit="player"
				buff.rank = 0
				buff.untilCancelled = true
				buff.filter="HELPFUL"
			end
		--verify if one of these are already included in the missing buffs
		elseif (MissingBuffs and (MissingBuffs["Power Word: Fortitude"] > -1)) then
			local buff=self.auras[key][MissingBuffs["Power Word: Fortitude"]]
			buff.enabled=false;
			buff.ignore=false;
			--Print("[Removed Buff: PW: Fort] Index:"..MissingBuffs["Power Word: Fortitude"])
			MissingBuffs["Power Word: Fortitude"] = -1;
		end
		if ((englishClass ~= "ROGUE") and (englishClass ~= "WARRIOR") and (englishClass ~= "DEATHKNIGHT")) then
			if ((CurrentBuffs["Divine Spirit"] == nil and CurrentBuffs["Prayer of Spirit"] == nil)) then 
				if (MissingBuffs["Divine Spirit"] == nil or (MissingBuffs["Divine Spirit"] == -1)) then
					MissingBuffs["Divine Spirit"] = self:FindAvailableIndex(key,"missing");
					--Print("[Missing Buff: Divine Spirit] Index: "..MissingBuffs["Divine Spirit"])
					local buff = self.auras[key][MissingBuffs["Divine Spirit"]]
					buff.enabled = true
					buff.ignore = true
					buff.type = "missing"
					buff.name = "Missing: Divine Spirit"
					buff.icon = "Interface\\Icons\\Spell_Holy_DivineSpirit"
					buff.stack = 0
					buff.rank = 0
					buff.unit="player"
					buff.untilCancelled = true
					buff.filter="HELPFUL"
				end
			--verify if one of these are already included in the missing buffs
			elseif (MissingBuffs and (MissingBuffs["Divine Spirit"] > -1)) then
				local buff=self.auras[key][MissingBuffs["Divine Spirit"]]
				buff.enabled=false;
				buff.ignore=false;
				--Print("[Removed Buff: Divine Spirit] Index:"..MissingBuffs["Divine Spirit"])
				MissingBuffs["Divine Spirit"] = -1;
			end
		end
		if ((CurrentBuffs["Shadow Protection"] == nil and CurrentBuffs["Prayer of Shadow Protection"] == nil)) then 
			if (MissingBuffs["Shadow Protection"] == nil or (MissingBuffs["Shadow Protection"] == -1)) then
				MissingBuffs["Shadow Protection"] = self:FindAvailableIndex(key,"missing");
				-- Print("[Missing Buff: Shadow Protection] Index: "..MissingBuffs["Shadow Protection"])
				local buff = self.auras[key][MissingBuffs["Shadow Protection"]]
				buff.enabled = true
				buff.ignore = true
				buff.type = "missing"
				buff.name = "Missing: Shadow Protection"
				buff.icon = "Interface\\Icons\\Spell_Shadow_AntiShadow"
				buff.stack = 0
				buff.rank = 0
				buff.unit="player"
				buff.untilCancelled = true
				buff.filter="HELPFUL"
				--verify if one of these are already included in the missing buffs
			end	
		elseif (MissingBuffs and (MissingBuffs["Shadow Protection"] > -1)) then
			local buff=self.auras[key][MissingBuffs["Shadow Protection"]]
			buff.enabled=false;
			buff.ignore=false;
			-- Print("[Removed Buff: Shadow Protection] Index:"..MissingBuffs["Shadow Protection"])
			MissingBuffs["Shadow Protection"] = -1;
		end
	else -- if (Classes["PRIEST"]) then
		if (MissingBuffs) then 
			if (MissingBuffs["Shadow Protection"] > -1) then
				local buff=self.auras[key][MissingBuffs["Shadow Protection"]]
				buff.enabled=false;
				buff.ignore=false;
				-- Print("[(No priests)Removed Buff: Shadow Protection] Index:"..MissingBuffs["Shadow Protection"])
				MissingBuffs["Shadow Protection"] = -1;
			end
			if (MissingBuffs["Divine Spirit"] > -1) then
				local buff=self.auras[key][MissingBuffs["Divine Spirit"]]
				buff.enabled=false;
				buff.ignore=false;
				-- Print("[(No priests)Removed Buff: Divine Spirit] Index:"..MissingBuffs["Divine Spirit"])
				MissingBuffs["Divine Spirit"] = -1;
			end
			if ((MissingBuffs["Power Word: Fortitude"] > -1)) then
				local buff=self.auras[key][MissingBuffs["Power Word: Fortitude"]]
				buff.enabled=false;
				buff.ignore=false;
				-- Print("[(No priests)Removed Buff: PW: Fort] Index:"..MissingBuffs["Power Word: Fortitude"])
				MissingBuffs["Power Word: Fortitude"] = -1;
			end
		end
	end
   end

	--Print("-=[MissingBuff Index Start]=-")
	--Print("Missing: Divine Spirit Index: "..tostring(MissingBuffs["Divine Spirit"]))
	--Print("Missing: Arcane Int Index: "..tostring(MissingBuffs["Arcane Intellect"]))
	--Print("Missing: Mark of the Wild Index: "..tostring(MissingBuffs["Mark of the Wild"]))
	--Print("Missing: BlessingOfKings: "..tostring(MissingBuffs["Blessing of Kings"]))
    --Print("Missing: BlessingOfMight: "..tostring(MissingBuffs["Blessing of Might"]))
	--Print("Missing: BlessingOfWisdom: "..tostring(MissingBuffs["Blessing of Wisdom"]))
    --Print("Missing: BlessingOfSanc: "..tostring(MissingBuffs["Blessing of Sanctuary"]))
	--Print("Missing: PW: Fort: "..tostring(MissingBuffs["Power Word: Fortitude"]))
	--Print("Missing: ShadowProt: "..tostring(MissingBuffs["Shadow Protection"]))
	--Print("-=[MissingBuff Index Fin]=-")
end

function QoreysBB:UpdateClasses()
    local playerClass, englishClass = UnitClass("player");
   
    wipe(Classes); 
    Classes[englishClass]=true
   if (GetNumRaidMembers() > 0) then
        for i=1,GetNumRaidMembers() do
            playerClass, englishClass = UnitClass("raid"..i);
            --Print("[Qorey] - raid"..i.."' - "..englishClass);
            if (englishClass ~= nil) then
                --if (Classes[englishClass] == nil) then Print("[Qorey] - raid"..i.."' - "..englishClass) end
                Classes[englishClass]=true
            end
        end
        return
    end
    if (GetNumPartyMembers() > 0) then
        for i=1,GetNumPartyMembers() do
            playerClass, englishClass = UnitClass("party"..i);
            if (englishClass ~= nil) then
                Classes[englishClass]=true
            	--Print("[Qorey] - party"..i.."' - "..englishClass);
            end
        end
   end
end

function QoreysBB:PartyChanged()
    self:DisableMissingBuffs()
    self:VerifyMissingBuffs()
    self:UpdateDisplay("missing")
end

function QoreysBB:RaidChanged()
    self:DisableMissingBuffs()
    self:VerifyMissingBuffs()
    self:UpdateDisplay("missing")
end
